﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections;

namespace HierarchyWithoutCollection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new List<A>
            {
                new A
                {
                    A1 = "A 1",
                    A2 = "A 2",
                    B = new B
                    {
                        B1 = "B 1",
                        B2 = "B 2",
                        C = new C
                        {
                            C1 = "C 1",
                            C2 = "C 2",
                            D = new D
                            {
                                D1 = "D 1",
                                D2 = "D 2",
                                E = new E
                                {
                                    E1 = "E 1",
                                    E2 = "E 2",
                                }
                            }
                        }
                    }
                },
                new A
                {
                    A1 = "A 1",
                    A2 = "A 2",
                    B = new B
                    {
                        B1 = "B 1",
                        B2 = "B 2",
                        C = new C
                        {
                            C1 = "C 1",
                            C2 = "C 2",
                            D = new D
                            {
                                D1 = "D 1",
                                D2 = "D 2",
                                E = new E
                                {
                                    E1 = "E 1",
                                    E2 = "E 2",
                                }
                            }
                        }
                    }
                },            
            };
        }
    }

    public class A
    {
        public string A1 { get; set; }
        public string A2 { get; set; }
        public B B { get; set; }
    }

    public class B
    {
        public string B1 { get; set; }
        public string B2 { get; set; }
        public C C { get; set; }
    }

    public class C
    {
        public string C1 { get; set; }
        public string C2 { get; set; }
        public D D { get; set; }
    }

    public class D
    {
        public string D1 { get; set; }
        public string D2 { get; set; }
        public E E { get; set; }
    }

    public class E
    {
        public string E1 { get; set; }
        public string E2 { get; set; }
    }

    public class ObjectToCollectionConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            ArrayList list = new ArrayList();
            list.Add(value);

            return list;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

}
